/*---------------------------------------------------------------------------
    Workfile:CConnection.cpp
    Archive: VideoManager Project

    Description: . Implementation of Class CConnection

    opyright (C) 2002 KTS Computers.
    All rights reserved.

    Last Author:  Tom,Jais T Mathew
    Last Modtime:  01/05/2002
    Last Revision:

---------------------------------------------------------------------------*/
#include "stdafx.h"
#include "Connection.h"
#include "Recordset.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

EXTERN_C const GUID FAR CLSID_CADOConnection = { 0x00000514, 0, 0x10,{ 0x80,0,0,0xAA,0,0x6D,0x2E,0xA4}};
EXTERN_C const IID FAR IID_IADOConnection =  { 0x00000550, 0, 0x10,{ 0x80,0,0,0xAA,0,0x6D,0x2E,0xA4}};

/*---------------------------------------------------------------------------
	Function Name: CConnection::~CConnection
	Return Value:
	Parameters:
	Remarks:  Destructor for CConnection
---------------------------------------------------------------------------*/
CConnection::~CConnection()
{
	if( m_pConn )
	{
		//close the connection
		Close();

		//Release the connection
		m_pConn->Release();
		m_pConn = NULL;

	}
	CoUninitialize();
}


/*---------------------------------------------------------------------------
	Function Name: IsOpen
	Return Value: long
	Parameters:  None
	Remarks:  return TRUE if connection is in open state and else FALSE
---------------------------------------------------------------------------*/
BOOL CConnection::IsOpen()
{
	//return the state of connection
	//  0 means close
	//  1 means opend.

	long lState = 0;
	
	if(m_pConn)
	{
		HRESULT hr =  m_pConn->get_State(&lState);
	}
	
	return lState;
}


/*---------------------------------------------------------------------------
	Function Name: CConnection::Open
	Return Value: HRESULT  of Open
	Parameters: pszDataSource: The data source for the connection
			    pcszProvider: The provider for the connection
	Remarks:  Open the connection
---------------------------------------------------------------------------*/
HRESULT CConnection::Open(LPCTSTR lpszConnection, LPCTSTR lpszUserName,LPCTSTR lpszPassword)
{

	HRESULT hr = 0;
	
	//create an instance if it is not created
	if(!m_pConn)
	{

		hr = CoCreateInstance(CLSID_CADOConnection,
						   NULL,
						   CLSCTX_INPROC_SERVER,
						   IID_IADOConnection,
						   (LPVOID*) &m_pConn);

		//check the result of CreateInstance
		//modified
		if(hr!=S_OK)
			return E_FAIL;
	}
	else
	{
		Close();
	}

	//check m_pConn is valid and it is not opened
	if(!IsOpen())
	{
		hr = m_pConn->Open(lpszConnection,lpszUserName,lpszPassword,adOpenUnspecified); 
	}	

	return hr;// return the status of Open

}

/*---------------------------------------------------------------------------
	Function Name: CConnection::Close
	Return Value: HRESULT  of Close
	Parameters:none
	Remarks:  Close the connection
---------------------------------------------------------------------------*/
HRESULT CConnection::Close()
{
	 //close the connection if it is opened.
	//check m_pConn is valid and it is opened
	HRESULT hr=0;
	if(IsOpen())
		hr = m_pConn->Close();
	return hr;
}

